from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, File, Float, Boolean, Int

Openswathrtnormalizer_V0_1_0 = CommandToolBuilder(tool="OpenSwathRTNormalizer", base_command=["OpenSwathRTNormalizer"], inputs=[ToolInput(tag="in_in", input_type=String(optional=True), prefix="-in", doc=InputDocumentation(doc="*            Input files separated by blank (valid formats: 'mzML')")), ToolInput(tag="in_tr", input_type=File(optional=True), prefix="-tr", doc=InputDocumentation(doc="*             Transition file with the RT peptides ('TraML' or 'csv') (valid formats: 'csv', 'traML')")), ToolInput(tag="in_out", input_type=File(optional=True), prefix="-out", doc=InputDocumentation(doc="*            Output file (valid formats: 'trafoXML')")), ToolInput(tag="in_rt_norm", input_type=File(optional=True), prefix="-rt_norm", doc=InputDocumentation(doc="RT normalization file (how to map the RTs of this run to the ones stored in the library) (valid formats: 'trafoXML')")), ToolInput(tag="in_min_rsq", input_type=Float(optional=True), prefix="-min_rsq", doc=InputDocumentation(doc="Minimum r-squared of RT peptides regression (default: '0.95')")), ToolInput(tag="in_min_coverage", input_type=Float(optional=True), prefix="-min_coverage", doc=InputDocumentation(doc="Minimum relative amount of RT peptides to keep (default: '0.6')")), ToolInput(tag="in_estimate_best_peptides", input_type=Boolean(optional=True), prefix="-estimateBestPeptides", doc=InputDocumentation(doc="Whether the algorithms should try to choose the best peptides based on their peak shape for normalization. Use this option you do not expect all your peptides to be detected in a sample and too many 'bad' peptides enter the outlier removal step (e.g. due to them being endogenous peptides or using a less curated list of peptides).")), ToolInput(tag="in_ini", input_type=File(optional=True), prefix="-ini", doc=InputDocumentation(doc="Use the given TOPP INI file")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="-threads", doc=InputDocumentation(doc="Sets the number of threads allowed to be used by the TOPP tool (default: '1')")), ToolInput(tag="in_write_ini", input_type=File(optional=True), prefix="-write_ini", doc=InputDocumentation(doc="Writes the default configuration file")), ToolInput(tag="in_helphelp", input_type=Boolean(optional=True), prefix="--helphelp", doc=InputDocumentation(doc="Shows all options (including advanced)"))], outputs=[ToolOutput(tag="out_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out", type_hint=File()), doc=OutputDocumentation(doc="*            Output file (valid formats: 'trafoXML')"))], container="quay.io/biocontainers/openms:2.6.0--h4afb90d_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Openswathrtnormalizer_V0_1_0().translate("wdl")

